(function () {
    "use strict";

    angular.module('core').controller('produtoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', '$q', '$alert', '$confirm', 'produtoService', 'lookupService'];

    function controller($scope, $timeout, $state, $stateParams, $q, $alert, $confirm, produtoService, lookupService) {
        $scope.initializeLayout('Produto');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            statusInicialProduto: 0,
            tabCorrente: 0,
            tabs: {
                Detalhes: 0,
                Variacoes: 1,
                Midias: 2,
                Observacoes: 3,
                Fisco: 4,
                CodigosBarras: 5,
                Precos: 6,
                Looks: 7,
                Combinados: 8,
                Similares: 9,
            }
        };
        $scope.popups = {
            midia: { ativo: false, tabCorrente: 0 },
            colecao: { ativo: false },
            grupo: { ativo: false },
            fabricacao: { ativo: false }
        };
        $scope.auxiliar = {
            marca: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllMarca({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            linha: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllLinha({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tipo: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            colecao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllColecao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grade: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrade({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            composicao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllComposicao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupo: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupo({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            fornecedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFornecedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            unidade: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllUnidade({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            varianteBasica: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllVarianteBasica({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoFiscalProduto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoComposicaoImposto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoComposicaoImposto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            ncm: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllNCM({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            origemTributo: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllOrigemTributo({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            situacaoTributaria: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllSituacaoTributaria({ chaves: chaves, filtroEm: [{ Imposto: { Codigo: '1' } }, { Imposto: { Codigo: '44' } }] })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            substituicaoTributaria: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllSubstituicaoTributaria({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tabelaPreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            look: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllLook({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            produto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };
        $scope.filhas = {
            variante: {
                prepareNew: function () {
                    $scope.state.vazio = false;
                    produtoService
                        .prepareNewVariante($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                }
                                $scope.state.vazio = !$scope.state.item;
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            precoProduto: {
                prepareNew: function () {
                    $scope.state.vazio = false;
                    produtoService
                        .prepareNewPrecoProduto($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                }
                                $scope.state.vazio = !$scope.state.item;
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            midia: {
                prepareNew: function () {
                    $scope.state.vazio = false;
                    produtoService
                        .prepareNewMidia($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                }
                                $scope.state.vazio = !$scope.state.item;
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
                next: function () {
                    if ($scope.state.item.Midias.length) {
                        if ($scope.popups.midia.tabCorrente < $scope.state.item.Midias.length - 1)
                            $scope.popups.midia.tabCorrente++;
                        else
                            $scope.popups.midia.tabCorrente = 0;
                    }
                },
                prior: function () {
                    if ($scope.state.item.Midias.length) {
                        if ($scope.popups.midia.tabCorrente > 0)
                            $scope.popups.midia.tabCorrente--;
                        else
                            $scope.popups.midia.tabCorrente = $scope.state.item.Midias.length - 1;
                    }
                },
                toggle: function (index) {
                    if ($scope.state.item.Midias.length) {
                        if (index)
                            $scope.popups.midia.tabCorrente = index;
                        else
                            $scope.popups.midia.tabCorrente = 0;
                        $scope.popups.midia.ativo = !$scope.popups.midia.ativo;
                    }
                },
            },
            codigoBarra: {
                prepareNew: function () {
                    $scope.state.vazio = false;
                    produtoService
                        .prepareNewCodigoBarra($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                }
                                $scope.state.vazio = !$scope.state.item;
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            combinado: {
                filtro: { codigo: '' },
                prepareNew: function () {
                    $scope.state.vazio = false;
                    produtoService
                        .prepareNewCombinado($scope.state.item, $scope.filhas.combinado.filtro.codigo)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                    $scope.filhas.combinado.filtro.codigo = '';
                                    $('[ng-model$="filhas.combinado.filtro.codigo"]').focus();
                                }
                                $scope.state.vazio = !$scope.state.item;
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            similar: {
                filtro: { codigo: '' },
                prepareNew: function () {
                    $scope.state.vazio = false;
                    produtoService
                        .prepareNewSimilar($scope.state.item, $scope.filhas.similar.filtro.codigo)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                    $scope.filhas.similar.filtro.codigo = '';
                                    $('[ng-model$="filhas.similar.filtro.codigo"]').focus();
                                }
                                $scope.state.vazio = !$scope.state.item;
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            produtoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.item = response.Data;
                            $scope.state.statusInicialProduto = $scope.state.item.Status;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.save = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;


            if (!angular.isUndefined($scope.state.item.Midias) && !angular.isUndefined($scope.state.item.Midias.length > 0)) {


                if (!angular.isUndefined(document.querySelector('input[name="principalItem"]:checked')) && document.querySelector('input[name="principalItem"]:checked') !== null) {

                    var itemPrincipal = document.querySelector('input[name="principalItem"]:checked').getAttribute("itemindex");

                    for (var i = 0; i < $scope.state.item.Midias.length; i++) {
                        $scope.state.item.Midias[i].IndicaPrincipal = false;
                    }


                    setTimeout(function () {
                        if (!angular.isUndefined(itemPrincipal))
                            $scope.state.item.Midias[itemPrincipal].IndicaPrincipal = true;

                    }, 50)

                }
                else {

                    if (!angular.isUndefined($scope.state.item.Midias[0])
                        && !angular.isUndefined($scope.state.item.Midias[0].IndicaPrincipal))
                        $scope.state.item.Midias[0].IndicaPrincipal = true;
                }
            }

            setTimeout(function () {
                produtoService
                    .save($scope.state.item)
                    .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $scope.state.item = response.Data;
                                $scope.historyBack();
                            }
                            $scope.state.carregando = false;
                            $scope.state.vazio = !$scope.state.item;
                        },
                        function (_error) {
                            $scope.state.carregando = false;
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        }
                    );
            }, 200)
        };
        $scope.delete = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            produtoService
                .delete($scope.state.item.ID)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        }
                        else {
                            $scope.historyBack();
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        }
        $scope.prepare = function () {
            $scope.state.vazio = false;
            produtoService
                .prepare($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    });
        };
        $scope.generateCodigoBarra = function () {

            $scope.state.carregando = true;
            $scope.state.vazio = false;
            produtoService
                .generateCodigoBarra($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {

                            $scope.state.item = response.Data;
                            $scope.tools.toastr.success('Codigos de Barras gerados com sucesso.');
                        }

                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );

        }

        $scope.toggleColecao = function () {
            $scope.popups.colecao.ativo = !$scope.popups.colecao.ativo;
        };
        $scope.toggleGrupo = function () {
            $scope.popups.grupo.ativo = !$scope.popups.grupo.ativo;
        };
        $scope.toggleFabricacao = function () {
            $scope.popups.fabricacao.ativo = !$scope.popups.fabricacao.ativo;
        };

        $scope.toolTip = function () {
            return $scope.state.statusInicialProduto === 2 ? "Este campo nao pode ser alterado pois o produto já esta aprovado!" : "";
        };

        $scope.imageUpload = function (event) {
            var files = event.target.files; //FileList object
            var fileTypes = ['jpg', 'jpeg', 'png'];  //acceptable file types



            for (var i = 0; i < files.length; i++) {

                var file = files[i];
                var extension = file.name.split('.').pop().toLowerCase(),  //file extension from input file
                    isSuccess = fileTypes.indexOf(extension) > -1;

                if (!isSuccess) {
                    $scope.tools.toastr.error('Somente extensão do tipo imagem é permitida');
                    continue;
                }

                var fsize = (file.size / 1024).toFixed();

                if (fsize > 800) {
                    $scope.tools.toastr.error('Atenção, a foto deve ter no maximo 800 kb. ');
                    continue;
                }

                var reader = new FileReader();
                reader.onload = $scope.imageIsLoaded;
                reader.readAsDataURL(file);
            }
        };
        $scope.imageIsLoaded = function (e) {
            $scope.$apply(function () {

                if (angular.isUndefined($scope.state.item.Midias))
                    $scope.item.Midias = [];

                var arquivo = { 'Titulo': 'Titulo Imagem' + $scope.state.item.Midias.length + 1, 'Tipo': 0, 'Sequencia': $scope.state.item.Midias.length, 'Arquivo': { 'Base64': e.target.result } };
                $scope.state.item.Midias.push(arquivo);
            });
        };
        $scope.openFileupload = function () {
            document.getElementById('imagemUpload').click();
        };
        $scope.getUrlImagemCapa = function (itens) {

            if (itens === null || angular.isUndefined(itens)) return;

            if (itens.length === 1)
                return itens[0].Arquivo.Url;

            for (var i = 0; i < itens.length; i++) {

                if (itens[i].IndicaPrincipal)
                    return itens[i].Arquivo.Url;
            }
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();